package spacewar;

public aspect RegistrationProtection {
    after() returning():
        (call(void Registry.register(SpaceObject)) ||
         call(void Registry.unregister(SpaceObject))) &&
        !(within(SpaceObject) && (withincode(new(..)) ||
                                  withincode(void die()))) {
        throw new IllegalAccessError(
           "This is an illegal call to " + thisJoinPoint + "\n" +
           "Only the constructor and the die() on SpaceObject\n" +
           "should call the primitive registry operations.");
    }

}
